package org.bdware.server.test;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.util.HashMap;
import java.util.Map;

public class HttpPostFormTest {

	public static void postForm(String url, Map<String, String> params) {

		String responseMessage = "";
		StringBuffer response = new StringBuffer();
		HttpURLConnection httpConnection = null;
		OutputStreamWriter out = null;
		BufferedReader reader = null;
		try {
			URL urlPost = new URL(url);
			httpConnection = (HttpURLConnection) urlPost.openConnection();
			httpConnection.setDoOutput(true);
			httpConnection.setDoInput(true);
			httpConnection.setRequestMethod("POST");
			httpConnection.setUseCaches(false);
			httpConnection.setInstanceFollowRedirects(true);
			httpConnection.setRequestProperty("Connection", "Keep-Alive");
			httpConnection.setRequestProperty("Charset", "UTF-8");
			// 设置边界
			String BOUNDARY = "----------" + System.currentTimeMillis();
			// httpConnection.setRequestProperty("Content-Type", "multipart/form-data;
			// boundary=" + BOUNDARY);
			httpConnection.setRequestProperty("Content-Type", "application/x-www-form-urlencoded;boundary=" + BOUNDARY);

			// 连接，从postUrl.openConnection()至此的配置必须要在connect之前完成，
			// 要注意的是connection.getOutputStream会隐含的进行connect。
			// 实际上只是建立了一个与服务器的tcp连接，并没有实际发送http请求。

			httpConnection.connect();
			out = new OutputStreamWriter(httpConnection.getOutputStream(), "UTF-8");

			StringBuffer sb = new StringBuffer();
			int count = params.size();
			for (String key : params.keySet()) {
				sb.append(key + "=" + URLEncoder.encode(params.get(key)));
				count--;
				if (count > 0)
					sb.append("&");
			}
			out.write(sb.toString());
			System.out.println("send_url:" + url);
			System.out.println("send_data:" + sb.toString());
			// flush and close
			out.flush();

		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			try {
				if (null != out) {
					out.close();
				}
				if (null != reader) {
					reader.close();
				}
				if (null != httpConnection) {
					httpConnection.disconnect();
				}
			} catch (Exception e2) {
				e2.printStackTrace();
			}
		}

		try {
			reader = new BufferedReader(new InputStreamReader(httpConnection.getInputStream(), "UTF-8"));
			while ((responseMessage = reader.readLine()) != null) {
				response.append(responseMessage);
				response.append("\n");
			}

			if (!"failure".equals(response.toString())) {
				System.out.println("success");
			} else {
				System.out.println("failue");
			}
			// 将该url的配置信息缓存起来
			System.out.println(response.toString());
			System.out.println(httpConnection.getResponseCode());
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		String url = "http://47.106.38.23:13081/register";

		Map<String, String> params = new HashMap<String, String>();
		String sucFix = System.currentTimeMillis() + "_ContractLog";
		params.put("DOI", "86.5000.470/" + sucFix);
		params.put("Description", "Contract Log");
		params.put("Interface", "");
		params.put("Address", "");
		params.put("PublicKey", "");
		params.put("Signature", "");
		// http://47.106.38.23:8080/idsystem/doDetail.html?doi=86.5000.470/1570626378959_ContractLog
		postForm(url, params);
	}
}
